package cz.frantovo.springDemo1.dao;

import cz.frantovo.springDemo1.KnihaDAORemote;
import cz.frantovo.springDemo1.dto.Kniha;
import java.util.Collection;
import javax.annotation.Resource;
import javax.ejb.Stateless;
import javax.sql.DataSource;
import org.springframework.jdbc.core.JdbcTemplate;

/**
 * Pro zjednodušení bez <a href="http://hg.frantovo.cz/SuperDAO/">SuperDao</a>.
 * @author fiki
 */
@Stateless
public class KnihaDAO implements KnihaDAORemote {

    @Resource(mappedName = "jdbc/sqlVyuka/piskoviste")
    private DataSource dataSource;
    private KnihaRowMapper knihaRowMapper = new KnihaRowMapper();
    JdbcTemplate t = new JdbcTemplate(dataSource);

    public Collection<Kniha> getKnihy() {
	return t.query("SELECT * FROM sbirka.kniha;", knihaRowMapper);
    }

    public int ulozKnihu(Kniha k) {
	return t.update("UPDATE kniha SET (nazev, autor, datum, isbn, pocet_stran, rok_vydani, id) VALUES (?,?,?,?,?,?,?)", new KnihaPSSetter(k));
    }
}
